HDU5543 Pick The Sticks(01背包)

来源:互联网 发布:收购博客玩家数据 编辑:程序博客网 时间:2024/06/01 07:57

Pick The Sticks

Time Limit: 15000/10000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)
Total Submission(s): 1807    Accepted Submission(s): 576


Problem Description
The story happened long long ago. One day, Cao Cao made a special order called "Chicken Rib" to his army. No one got his point and all became very panic. However, Cao Cao himself felt very proud of his interesting idea and enjoyed it.

Xiu Yang, one of the cleverest counselors of Cao Cao, understood the command Rather than keep it to himself, he told the point to the whole army. Cao Cao got very angry at his cleverness and would like to punish Xiu Yang. But how can you punish someone because he's clever? By looking at the chicken rib, he finally got a new idea to punish Xiu Yang.

He told Xiu Yang that as his reward of encrypting the special order, he could take as many gold sticks as possible from his desk. But he could only use one stick as the container.

Formally, we can treat the container stick as an L length segment. And the gold sticks as segments too. There were many gold sticks with different length ai and value vi. Xiu Yang needed to put these gold segments onto the container segment. No gold segment was allowed to be overlapped. Luckily, Xiu Yang came up with a good idea. On the two sides of the container, he could make part of the gold sticks outside the container as long as the center of the gravity of each gold stick was still within the container. This could help him get more valuable gold sticks.

As a result, Xiu Yang took too many gold sticks which made Cao Cao much more angry. Cao Cao killed Xiu Yang before he made himself home. So no one knows how many gold sticks Xiu Yang made it in the container.

Can you help solve the mystery by finding out what's the maximum value of the gold sticks Xiu Yang could have taken?
 

Input
The first line of the input gives the number of test cases, T(1T100)T test cases follow. Each test case start with two integers, N(1N1000) and L(1L2000), represents the number of gold sticks and the length of the container stick. N lines follow. Each line consist of two integers, ai(1ai2000) and vi(1vi109), represents the length and the value of the ith gold stick.
 

Output
For each test case, output one line containing Case #x: y, where x is the test case number (starting from 1) and y is the maximum value of the gold sticks Xiu Yang could have taken.
 

Sample Input
43 74 12 18 13 74 22 18 43 54 12 28 91 110 3
 

Sample Output
Case #1: 2Case #2: 6Case #3: 11Case #4: 3
Hint
In the third case, assume the container is lay on x-axis from 0 to 5. Xiu Yang could put the second gold stick center at 0 and put the third gold stick center at 5, so none of them will drop and he can get total 2+9=11 value. In the fourth case, Xiu Yang could just put the only gold stick center on any position of [0,1], and he can get the value of 3.
 

Source
The 2015 China Collegiate Programming Contest
 

Recommend
wange2014   |   We have carefully selected several similar problems for you:  6022 6021 6020 6019 6018 
开一个二维数组dp[i][k],i表示当前的长度,k表示共有几个一半的,因为只有两个边缘所以k最大为2,由于边缘放入桌子上的一定>=自身的长度/2,由于/2以后可能为分数导致无法用数组的角标标记,所以干脆全乘2
#include<stdio.h>#include<stdlib.h>#include<algorithm>#include<string.h>#define mem(a,b) memset(a,b,sizeof(a))#define ll long long#define maxn 2010using namespace std;ll dp[maxn<<1][3];struct node{    ll c,v;}e[maxn];int main(){    ll t,n,T=0,l;    scanf("%d",&t);    while(t--)    {        mem(dp,0);        scanf("%lld%lld",&n,&l);        l<<=1;        ll ans=0;        for(ll i=0;i<n;i++)        {            scanf("%lld%lld",&e[i].c,&e[i].v);            e[i].c<<=1;            if(e[i].v>ans)                ans=e[i].v;        }        for(ll i=0;i<n;i++)        {            for(ll j=l;j>=e[i].c/2;j--)            {                for(ll k=0;k<3;k++)                {                    if(j>=e[i].c)                        dp[j][k]=max(dp[j][k],dp[j-e[i].c][k]+e[i].v);                    if(k>0)                        dp[j][k]=max(dp[j][k],dp[j-e[i].c/2][k-1]+e[i].v);                        ans=max(ans,dp[j][k]);                }            }        }        printf("Case #%lld: %lld\n",++T,ans);    }}


0 0
原创粉丝点击